searchNodes=[{"doc":"Top-level namespace for GenMagic, the libmagic client for Elixir.See GenMagic.Server or the README for usage.","ref":"GenMagic.html","title":"GenMagic","type":"module"},{"doc":"Contains convenience functions for one-off use.","ref":"GenMagic.Helpers.html","title":"GenMagic.Helpers","type":"module"},{"doc":"Runs a one-shot process without supervision.Useful in tests, but not recommended for actual applications.Exampleiex(1)&gt; {:ok, result} = GenMagic.Helpers.perform_once(&quot;.&quot;) iex(2)&gt; result %GenMagic.Result{content: &quot;directory&quot;, encoding: &quot;binary&quot;, mime_type: &quot;inode/directory&quot;}","ref":"GenMagic.Helpers.html#perform_once/2","title":"GenMagic.Helpers.perform_once/2","type":"function"},{"doc":"Represents the results obtained from libmagic.Please note that this struct is only returned if the underlying check has succeeded.","ref":"GenMagic.Result.html","title":"GenMagic.Result","type":"module"},{"doc":"Represents the result.Contains the MIME type, Encoding and Content fields returned by libmagic, as per the flags:MIME Type: MAGIC_FLAGS_COMMON|MAGIC_MIME_TYPEEncoding: MAGIC_FLAGS_COMMON|MAGIC_MIME_ENCODINGType Name (Content): MAGIC_FLAGS_COMMON|MAGIC_NONE","ref":"GenMagic.Result.html#t:t/0","title":"GenMagic.Result.t/0","type":"type"},{"doc":"Provides access to the underlying libmagic client, which performs file introspection.The Server needs to be supervised, since it will terminate if it receives any unexpected error.","ref":"GenMagic.Server.html","title":"GenMagic.Server","type":"module"},{"doc":"Returns the default Child Specification for this Server for use in Supervisors.You can override this with Supervisor.child_spec/2 as required.","ref":"GenMagic.Server.html#child_spec/1","title":"GenMagic.Server.child_spec/1","type":"function"},{"doc":"Determines the type of the file provided.","ref":"GenMagic.Server.html#perform/3","title":"GenMagic.Server.perform/3","type":"function"},{"doc":"Starts a new Server.See option/0 for further details.","ref":"GenMagic.Server.html#start_link/1","title":"GenMagic.Server.start_link/1","type":"function"},{"doc":"Returns status of the Server.","ref":"GenMagic.Server.html#status/2","title":"GenMagic.Server.status/2","type":"function"},{"doc":"Stops the Server with reason :normal and timeout :infinity.","ref":"GenMagic.Server.html#stop/1","title":"GenMagic.Server.stop/1","type":"function"},{"doc":"Stops the Server with the specified reason and timeout.","ref":"GenMagic.Server.html#stop/3","title":"GenMagic.Server.stop/3","type":"function"},{"doc":"Represents values accepted as startup options, which can be passed to start_link/1.:name: If present, this will be the registered name for the underlying process. Note that :gen_statem requires {:local, name}, but given widespread GenServer convention, atoms are accepted and will be converted to {:local, name}.:startup_timeout: Specifies how long the Server waits for the C program to initialise. However, if the underlying C program exits, then the process exits immediately.Can be set to :infinity.:process_timeout: Specifies how long the Server waits for each request to complete.Can be set to :infinity. Please note that, if you have chosen a custom timeout value, you should also pass it when using GenMagic.Server.perform/3.:recycle_threshold: Specifies the number of requests processed before the underlying C program is recycled.Can be set to :infinity if you do not wish for the program to be recycled.:database_patterns: Specifies what magic databases to load; you can specify a list of either Path Patterns (see Path.wildcard/2) or :default to instruct the C program to load the appropriate databases.For example, if you have had to add custom magics, then you can set this value to:[:default, &quot;path/to/my/magic&quot;]","ref":"GenMagic.Server.html#t:option/0","title":"GenMagic.Server.option/0","type":"type"},{"doc":"Current state of the Server::starting: This is the initial state; the Server will attempt to start the underlying Port and the libmagic client, then automatically transition to either Available or Crashed.:available: This is the default state. In this state the Server is able to accept requests and they will be replied in the same order.:processing: This is the state the Server will be in if it is processing requests. In this state, further requests can still be lodged and they will be processed when the Server is available again.For proper concurrency, use a process pool like Poolboy, Sbroker, etc.:recycling: This is the state the Server will be in, if its underlying C program needs to be recycled. This state is triggered whenever the cycle count reaches the defined value as per :recycle_threshold.In this state, the Server is able to accept requests, but they will not be processed until the underlying C server program has been started again.","ref":"GenMagic.Server.html#t:state/0","title":"GenMagic.Server.state/0","type":"type"},{"doc":"Represents the reference to the underlying server, as returned by :gen_statem.","ref":"GenMagic.Server.html#t:t/0","title":"GenMagic.Server.t/0","type":"type"},{"doc":"Represents Status of the underlying Server.","ref":"GenMagic.Server.Status.html","title":"GenMagic.Server.Status","type":"module"},{"doc":"Represnets Staus of the Server.:state: Represents the current state of the Server:cycles: Represents the number of cycles the Server has run; note that this resets if recycling is enabled.","ref":"GenMagic.Server.Status.html#t:t/0","title":"GenMagic.Server.Status.t/0","type":"type"},{"doc":"GenMagicGenMagic provides supervised and customisable access to libmagic using a supervised external process.With this library, you can start an one-off process to run a single check, or run the process as a daemon if you expect to run many checks.","ref":"readme.html","title":"GenMagic","type":"extras"},{"doc":"The package can be installed by adding gen_magic to your list of dependencies in mix.exs:def deps do [ {:gen_magic, &quot;~&gt; 1.0.4&quot;} ] endYou must also have libmagic installed locally with headers, alongside common compilation tools (i.e. build-essential). These can be acquired by apt-get, yum, brew, etc.Additionally, pkg-config is required as it is used to locate the correct version of libmagic during compilation.Compilation of the underlying C program is automatic and handled by elixir_make.","ref":"readme.html#installation","title":"GenMagic - Installation","type":"extras"},{"doc":"Depending on the use case, you may utilise a single (one-off) GenMagic process without reusing it as a daemon, or utilise a connection pool (such as Poolboy) in your application to run multiple persistent GenMagic processes.To use GenMagic directly, you can use GenMagic.Helpers.perform_once/1:iex(1)&gt; GenMagic.Helpers.perform_once &quot;.&quot; {:ok, %GenMagic.Result{ content: &quot;directory&quot;, encoding: &quot;binary&quot;, mime_type: &quot;inode/directory&quot; }}To use the GenMagic server as a daemon, you can start it first, keep a reference, then feed messages to it as you require:{:ok, pid} = GenMagic.Server.start_link([]) {:ok, result} = GenMagic.Server.perform(pid, path)See GenMagic.Server.start_link/1 and GenMagic.Server.option/0 for more information on startup parameters.See GenMagic.Result for details on the result provided.","ref":"readme.html#usage","title":"GenMagic - Usage","type":"extras"},{"doc":"When using GenMagic.Server.start_link/1 to start a persistent server, or GenMagic.Helpers.perform_once/2 to run an ad-hoc request, you can override specific options to suit your use case.NameDefaultDescription:startup_timeout1000Number of milliseconds to wait for client startup:process_timeout30000Number of milliseconds to process each request:recycle_threshold10Number of cycles before the C process is replaced:database_patterns[:default]Databases to loadSee GenMagic.Server.option/0 for details.Use CasesAd-Hoc RequestsFor ad-hoc requests, you can use the helper method GenMagic.Helpers.perform_once/2:iex(1)&gt; GenMagic.Helpers.perform_once(Path.join(File.cwd!(), &quot;Makefile&quot;)) {:ok, %GenMagic.Result{ content: &quot;makefile script, ASCII text&quot;, encoding: &quot;us-ascii&quot;, mime_type: &quot;text/x-makefile&quot; }}Supervised RequestsThe Server should be run under a pool which provides concurrency and resiliency.Here we run it under a supervisor:iex(1)&gt; {:ok, pid} = Supervisor.start_link([{GenMagic.Server, name: :gen_magic}], strategy: :one_for_one) {:ok, #PID&lt;0.199.0&gt;}Now we can ask it to inspect a file:iex(2)&gt; GenMagic.Server.perform(:gen_magic, Path.expand(&quot;~/.bash_history&quot;)) {:ok, [mime_type: &quot;text/plain&quot;, encoding: &quot;us-ascii&quot;, content: &quot;ASCII text&quot;]}Note that in this case we have opted to use a named process.Check Uploaded FilesIf you use Phoenix, you can inspect the file from your controller:def upload(conn, %{&quot;upload&quot; =&gt; %{path: path}}) do, {:ok, result} = GenMagic.Helpers.perform_once(:gen_magic, path) text(conn, &quot;Received your file containing \#{result.content}&quot;) endObviously, it will be more ideal if you have wrapped GenMagic.Server in a pool such as Poolboy, to avoid constantly starting and stopping the underlying C program.","ref":"readme.html#configuration","title":"GenMagic - Configuration","type":"extras"},{"doc":"Soak TestRun an endless cycle to prove that the program is resilient:find /usr/share/ -name *png | xargs mix run test/soak.exs find . -name *ex | xargs mix run test/soak.exs","ref":"readme.html#notes","title":"GenMagic - Notes","type":"extras"},{"doc":"During design and prototype development of this library, the Author has drawn inspiration from the following individuals, and therefore thanks all contributors for their generosity:Mr James EveryEnhanced Elixir Wrapper (based on GenServer)Initial Hex packaging (v.0.22)Soak Testing","ref":"readme.html#acknowledgements","title":"GenMagic - Acknowledgements","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"AddedAdded support for process recycling (evadne).Added documentation (evadne).ChangedReplaced GenServer with :gen_statem (evadne).Changed API; added support for customisation.Refined tests and other aspects of the library (evadne).","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"AddedSoak testing script (devstopfix)ChangedReplaced Erlexec usage with Port (devstopfix)","ref":"changelog.html#0-20-83","title":"Changelog - 0.20.83","type":"extras"},{"doc":"AddedInitial Elixir wrapper with Erlexec (evadne)Intiial C program (evadne)","ref":"changelog.html#0-0-1","title":"Changelog - 0.0.1","type":"extras"}]